#define MAXSLICES 6

#define LT_DIRECTIONAL 1
#define LT_POINT 2
#define LT_SPOT 3

struct LightParam
{
	float3	Color;	
	float	SM;	
	float3	Direction;
	float	InvSMSize;	
	float3	Position;
	float	Specular;	
	matrix	MatSM;
	float4	SpotParam;
	float3	Attenuation;
	float	Radius;
	int		Type;
	int		SMFilter;
};

shared cbuffer cbLights
{
	const float Gauss3x3Weights[] = {0.0625, 0.125, 0.0625,
				 					 0.125, 0.25, 0.125,
				 					 0.0625, 0.125, 0.0625};

	const float2 PoissonOffsets[] = {float2(0.007937789, 0.73124397),
									float2(-0.10177308, -0.6509396),
									float2(-0.9906806, -0.63400936),
									float2(-0.5583586, -0.3614012),
									float2(0.7163085, 0.22836149),
									float2(-0.65210974, 0.37117887),
									float2(-0.12714535, 0.112056136),
									float2(0.48898065, -0.66669613),
									float2(-0.9744036, 0.9155904),
									float2(0.9274436, -0.9896486),
									float2(0.9782181, 0.90990245),
									float2(0.96427417, -0.25506377),
									float2(-0.5021933, -0.9712455),
									float2(0.3091557, -0.17652994),
									float2(0.4665941, 0.96454906),
									float2(-0.461774, 0.9360856)};

	bool		g_ShadowMapping;
	int			g_LightCount;
	//int			g_DirCount;
	//int			g_SpotCount;
	//int			g_PointCount;
	float4x4	g_matView : VIEW;
	int			g_PSSMLightIndex;
	uint		g_PSSMSliceCount;
	float4		g_PSSMSliceNear[MAXSLICES-1];
	row_major float4x4	g_matPSSM[MAXSLICES]; //maxsplits
	
	LightParam	g_Lights[MAXLIGHTS];
};

shared Texture2D g_txPSSM[MAXSLICES];
shared Texture2D g_tx2DShadowMaps[MAXLIGHTS];
shared TextureCube g_txCubeShadowMaps[MAXLIGHTS];

shared SamplerComparisonState g_sShadowMap
{
	//2x2 PCF lookup
    Filter = COMPARISON_MIN_MAG_LINEAR_MIP_POINT; 
	//Filter = COMPARISON_MIN_MAG_MIP_POINT; 
	//ComparisonFunc = GREATER_EQUAL;
	ComparisonFunc = GREATER;
    AddressU = Clamp;
    AddressV = Clamp;
};
