#include "Skinning.fxh"

//define vertex input
struct SkinVertexInput
{
	float3 Pos : POSITION;
	float3 Normal : NORMAL;
	VERTEXSKININFO
};
#define SM_INPUT SkinVertexInput

//define function to get the position
float3 GetSkinnedPos(SkinVertexInput i)
{
	float4 p = float4(i.Pos, 1);
	
	SkinVert(i.SkinWeights, i.BoneIndices, p);

	return p.xyz;
}
#define SM_GETPOSITION GetSkinnedPos

float3 GetSkinnedNormal(SkinVertexInput i)
{
	float4 p = 0;
	float3 normal = i.Normal;
	
	SkinVert(i.SkinWeights, i.BoneIndices, p, i.Normal);

	return normalize(normal);
}
#define SM_GETNORMAL GetSkinnedNormal

#include "ShadowMapping.fx"