#ifndef MAYLAYERS
#define MAXLAYERS 8
#endif

shared cbuffer cbPatch
{
	float4  g_PatchOffsetScale; //offset = xyz, scale = w
	//lod, psize, position of patch in next lod
	int4	g_LODSizePatchPos;

	int g_LayerCount;
	float g_TexScales[MAXLAYERS + 1];
	float g_MaskRes[MAXLAYERS];
};

shared cbuffer cbGloabl
{
	row_major matrix g_matVP : VIEWPROJ;
	float3 g_CamPos : CAMPOS;
    float3 g_AmbientLight : AMBIENT;
	uint  g_PatchSize;
	uint  g_Tiling;
	float g_UnitSize;
};

struct PS_IN
{
	float4 PosT		: SV_Position;
	float3 Normal	: NORMAL;
	float3 Pos		: TEXCOORD0;
	float2 MaskCoord : TEXCOORD1;
	float LodBlend : TEXCOORD2;
	float3 Extinction : TEXCOORD3;
	float3 Inscatter : TEXCOORD4;
};

shared Texture2D	g_txHeightmap;
shared Texture2D	g_txNormal;
shared Texture2D	g_txHeightmapNext;
shared Texture2D	g_txNormalNext;
shared Texture2D	g_txLayers[MAXLAYERS+1];
shared Texture2D	g_txMasks[MAXLAYERS];

shared SamplerState g_sBilinear
{
    Filter = MIN_MAG_LINEAR_MIP_POINT;
	AddressU = Wrap;
    AddressV = Wrap;
};

shared SamplerState g_sAniso
{
	Filter = ANISOTROPIC;
    //MaxAnisotropy = 16;
    AddressU = Wrap;
    AddressV = Wrap;
};

shared RasterizerState RasNoCull
{
	CullMode = Back;
    //FillMode = Wireframe;
	FillMode = Solid;
	MultisampleEnable = true;
	AntialiasedLineEnable = true;
};

shared DepthStencilState DSState
{
	DepthEnable = true;
	DepthWriteMask = ALL;
	DepthFunc = LESS;
	StencilEnable = false;
};

shared BlendState Blend
{
	AlphaToCoverageEnable = FALSE;
	RenderTargetWriteMask[0] = 0x0F;
    BlendEnable[0] = FALSE;
};
