float3 TMLinear(float3 color, float key, float luminance)
{    
    return color * key / (luminance + 0.00001f);
}

float3 TMReinhard(float3 color, float key, float luminance)
{
	float3 colorscale = color * key / (luminance + 0.00001f);
    return colorscale / (colorscale + 1);
}

float3 TMReinhardMod(float3 color, float key, float luminance, float invwhitelumsq)
{
	float3 colorscale = color * key / (luminance + 0.00001f);
    return colorscale * (1 + colorscale * invwhitelumsq) / (0.5f + colorscale);
}

float3 TMLogarithmic(float3 color, float key, float luminance)
{
	return key * log(color + 1) / log(luminance + 1);
}

float3 TMAdaptiveLog(float3 color, float key, float luminance, float adaptiveB)
{
	return key / log10(luminance + 1) * log(color + 1) / log(2 + 8 * pow(color / luminance, log(adaptiveB) / log(0.5)) );
}

float3 TMExponential(float3 color, float key, float luminance)
{
	//return 1.0f - exp(-key / (luminance + 0.00001f) * color);
	return 0 ;
}
